#!/usr/bin/env python

class StateMachine :
    __transitions = {}
    __currentState = None;
    __errorState = None;
    __startState = None;

    def addTransition(self, state, inputChar, followState):
        startStateAndInput = (state, inputChar)
        
        self.__transitions[startStateAndInput] = followState

    def getCurrentState(self):
        return self.__currentState

    def processChar(self, inputChar):
        nextState = self.__transitions.get((self.__currentState, inputChar))
        
        self.__currentState = nextState if nextState != None else self.__errorState

        return self.__currentState;

    def setErrorState(self, errorState):
        self.__errorState = errorState
    
    def setStartState(self, startState):
        self.__startState = startState
        self.__currState = self.__startState

    def reset(self):
        self.__currentState = self.__startState;
